/* predicate.c generated by valac 0.40.19, the Vala compiler
 * generated from predicate.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <string.h>

typedef gboolean (*SeahorsePredicateFunc) (GObject* obj, void* custom_target);

#define SEAHORSE_TYPE_PREDICATE (seahorse_predicate_get_type ())
typedef struct _SeahorsePredicate SeahorsePredicate;
typedef enum  {
	SEAHORSE_USAGE_NONE = 0,
	SEAHORSE_USAGE_SYMMETRIC_KEY = 1,
	SEAHORSE_USAGE_PUBLIC_KEY = 2,
	SEAHORSE_USAGE_PRIVATE_KEY = 3,
	SEAHORSE_USAGE_CREDENTIALS = 4,
	SEAHORSE_USAGE_IDENTITY = 5,
	SEAHORSE_USAGE_OTHER = 10
} SeahorseUsage;


#define SEAHORSE_TYPE_USAGE (seahorse_usage_get_type ())
typedef enum  {
	SEAHORSE_FLAG_NONE = 0,
	SEAHORSE_FLAG_IS_VALID = 0x00000001,
	SEAHORSE_FLAG_CAN_ENCRYPT = 0x00000002,
	SEAHORSE_FLAG_CAN_SIGN = 0x00000004,
	SEAHORSE_FLAG_CAN_CERTIFY = 0x00000008,
	SEAHORSE_FLAG_CAN_AUTHENTICATE = 0x00000010,
	SEAHORSE_FLAG_EXPIRED = 0x00000100,
	SEAHORSE_FLAG_REVOKED = 0x00000200,
	SEAHORSE_FLAG_DISABLED = 0x00000400,
	SEAHORSE_FLAG_TRUSTED = 0x00001000,
	SEAHORSE_FLAG_PERSONAL = 0x00002000,
	SEAHORSE_FLAG_EXPORTABLE = 0x00100000,
	SEAHORSE_FLAG_DELETABLE = 0x10000000
} SeahorseFlags;


#define SEAHORSE_TYPE_FLAGS (seahorse_flags_get_type ())

struct _SeahorsePredicate {
	GType type;
	SeahorseUsage usage;
	SeahorseFlags flags;
	SeahorseFlags nflags;
	SeahorsePredicateFunc custom;
	void* custom_target;
};



GType seahorse_predicate_get_type (void) G_GNUC_CONST;
GType seahorse_usage_get_type (void) G_GNUC_CONST;
GType seahorse_flags_get_type (void) G_GNUC_CONST;
SeahorsePredicate* seahorse_predicate_dup (const SeahorsePredicate* self);
void seahorse_predicate_free (SeahorsePredicate* self);
gboolean seahorse_predicate_match (SeahorsePredicate *self,
                                   GObject* obj);


/**
     * Matches a seahorse object and a predicate
     *
     * @param obj The predicate to match
     *
     * @return false if predicate does not match the Object, true else
     */
gboolean
seahorse_predicate_match (SeahorsePredicate *self,
                          GObject* obj)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GType _tmp1_;
	SeahorseUsage _tmp5_;
	gboolean _tmp9_ = FALSE;
	SeahorseFlags _tmp10_;
	gboolean _tmp21_ = FALSE;
	SeahorsePredicateFunc _tmp22_;
	g_return_val_if_fail (obj != NULL, FALSE);
	_tmp1_ = (*self).type;
	if (_tmp1_ != ((GType) 0)) {
		gboolean _tmp2_ = FALSE;
		GType _tmp3_;
		_tmp3_ = (*self).type;
		if (g_type_is_a (G_TYPE_FROM_INSTANCE (obj), _tmp3_)) {
			GType _tmp4_;
			_tmp4_ = (*self).type;
			_tmp2_ = g_type_is_a (_tmp4_, G_TYPE_FROM_INSTANCE (obj));
		} else {
			_tmp2_ = FALSE;
		}
		_tmp0_ = !_tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = (*self).usage;
	if (_tmp5_ != SEAHORSE_USAGE_NONE) {
		SeahorseUsage obj_usage = 0;
		SeahorseUsage _tmp6_ = 0;
		SeahorseUsage _tmp7_;
		SeahorseUsage _tmp8_;
		obj_usage = SEAHORSE_USAGE_NONE;
		g_object_get (obj, "usage", &_tmp6_, NULL, NULL);
		obj_usage = _tmp6_;
		_tmp7_ = (*self).usage;
		_tmp8_ = obj_usage;
		if (_tmp7_ != _tmp8_) {
			result = FALSE;
			return result;
		}
	}
	_tmp10_ = (*self).flags;
	if (_tmp10_ != 0) {
		_tmp9_ = TRUE;
	} else {
		SeahorseFlags _tmp11_;
		_tmp11_ = (*self).nflags;
		_tmp9_ = _tmp11_ != 0;
	}
	if (_tmp9_) {
		SeahorseFlags obj_flags = 0U;
		SeahorseFlags _tmp12_ = 0U;
		gboolean _tmp13_ = FALSE;
		SeahorseFlags _tmp14_;
		gboolean _tmp17_ = FALSE;
		SeahorseFlags _tmp18_;
		obj_flags = SEAHORSE_FLAG_NONE;
		g_object_get (obj, "object-flags", &_tmp12_, NULL, NULL);
		obj_flags = _tmp12_;
		_tmp14_ = (*self).flags;
		if (_tmp14_ != SEAHORSE_FLAG_NONE) {
			SeahorseFlags _tmp15_;
			SeahorseFlags _tmp16_;
			_tmp15_ = obj_flags;
			_tmp16_ = (*self).flags;
			_tmp13_ = (_tmp16_ & _tmp15_) == _tmp15_;
		} else {
			_tmp13_ = FALSE;
		}
		if (_tmp13_) {
			result = FALSE;
			return result;
		}
		_tmp18_ = (*self).nflags;
		if (_tmp18_ != SEAHORSE_FLAG_NONE) {
			SeahorseFlags _tmp19_;
			SeahorseFlags _tmp20_;
			_tmp19_ = obj_flags;
			_tmp20_ = (*self).nflags;
			_tmp17_ = !((_tmp20_ & _tmp19_) == _tmp19_);
		} else {
			_tmp17_ = FALSE;
		}
		if (_tmp17_) {
			result = FALSE;
			return result;
		}
	}
	_tmp22_ = (*self).custom;
	if (_tmp22_ != NULL) {
		SeahorsePredicateFunc _tmp23_;
		void* _tmp24_;
		_tmp23_ = (*self).custom;
		_tmp24_ = (*self).custom_target;
		_tmp21_ = !_tmp23_ (obj, _tmp24_);
	} else {
		_tmp21_ = FALSE;
	}
	if (_tmp21_) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


SeahorsePredicate*
seahorse_predicate_dup (const SeahorsePredicate* self)
{
	SeahorsePredicate* dup;
	dup = g_new0 (SeahorsePredicate, 1);
	memcpy (dup, self, sizeof (SeahorsePredicate));
	return dup;
}


void
seahorse_predicate_free (SeahorsePredicate* self)
{
	g_free (self);
}


GType
seahorse_predicate_get_type (void)
{
	static volatile gsize seahorse_predicate_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_predicate_type_id__volatile)) {
		GType seahorse_predicate_type_id;
		seahorse_predicate_type_id = g_boxed_type_register_static ("SeahorsePredicate", (GBoxedCopyFunc) seahorse_predicate_dup, (GBoxedFreeFunc) seahorse_predicate_free);
		g_once_init_leave (&seahorse_predicate_type_id__volatile, seahorse_predicate_type_id);
	}
	return seahorse_predicate_type_id__volatile;
}



